local name = 'hidden-pole-1x1'
local type = 'lamp'

function on_built (lamp_entity) -- entity is a placed lamp
--	create_entity{name=…, position=…, direction=…, force=…, target=…, source=…, fast_replace=…, player=…, spill=…, raise_built=…, create_build_effect_smoke=…, spawn_decorations=…}
	local surface = lamp_entity.surface
	local position = lamp_entity.position
	local force = lamp_entity.force
	if not (lamp_entity.is_connected_to_electric_network()) then
		local hidden_pole = surface.create_entity{name=name, position=position, force=force}
		-- hidden_pole is a created hidden_pole
		local neighbours = hidden_pole.neighbours
		if neighbours then
			for i, target in pairs (neighbours.copper) do
--				game.print ('n: ' .. n.name)
				if target.name == name then
					local poles = target.neighbours.copper -- if the another lamp has a right connection
					hidden_pole.disconnect_neighbour(target)
					for i, p in pairs (poles) do -- check if we can connect it to other not hidden pole
						if not (p.name == name) then
--							game.print (p.name)
							hidden_pole.connect_neighbour(p)
						end
					end
				end
			end
		end
	--	game.print ('created')
	end

end


script.on_event(defines.events.on_built_entity, function(event)
  local entity = event.created_entity
  if entity and entity.type == type then
      on_built (entity)
  end
end)


script.on_event(defines.events.on_robot_built_entity, function(event)
  local entity = event.created_entity
  if entity and entity.type == type then
	 on_built (entity)
  end
end)


function on_remove (entity)
	local surface = entity.surface
	local position = entity.position
	local pole = surface.find_entity(name, position)
	if pole then 
		pole.destroy()
--		game.print ('destroyed')
	end
end

script.on_event(defines.events.on_entity_died, function(event) 
	local entity = event.entity
	if entity and entity.type == type then
		on_remove (entity)
	end	
end)

script.on_event(defines.events.on_player_mined_entity, function(event) 
	local entity = event.entity
	if entity and entity.type == type then
		on_remove (entity)
	end	
end)

script.on_event(defines.events.on_robot_mined, function(event) 
	local entity = event.entity
	if entity and entity.type == type then
		on_remove (entity)
	end	
end)
